Index: trunk/src/VBox/Main/src-client/ConsoleImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/ConsoleImpl.cpp	(revision 85744)
+++ trunk/src/VBox/Main/src-client/ConsoleImpl.cpp	(revision 85745)
@@ -9234,5 +9234,5 @@
 
     int rc = pVMMDev->hgcmHostCall("VBoxDragAndDropSvc",
-                                   DragAndDropSvc::HOST_DND_SET_MODE, 1 /* cParms */, &parm);
+                                   DragAndDropSvc::HOST_DND_FN_SET_MODE, 1 /* cParms */, &parm);
     if (RT_FAILURE(rc))
         LogRel(("Error changing drag and drop mode: %Rrc\n", rc));
Index: trunk/src/VBox/Main/src-client/GuestDnDPrivate.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/GuestDnDPrivate.cpp	(revision 85744)
+++ trunk/src/VBox/Main/src-client/GuestDnDPrivate.cpp	(revision 85745)
@@ -527,5 +527,5 @@
     switch (u32Function)
     {
-        case DragAndDropSvc::GUEST_DND_CONNECT:
+        case DragAndDropSvc::GUEST_DND_FN_CONNECT:
         {
             DragAndDropSvc::PVBOXDNDCBCONNECTDATA pCBData = reinterpret_cast<DragAndDropSvc::PVBOXDNDCBCONNECTDATA>(pvParms);
@@ -543,5 +543,5 @@
         }
 
-        case DragAndDropSvc::GUEST_DND_REPORT_FEATURES:
+        case DragAndDropSvc::GUEST_DND_FN_REPORT_FEATURES:
         {
             DragAndDropSvc::PVBOXDNDCBREPORTFEATURESDATA pCBData = reinterpret_cast<DragAndDropSvc::PVBOXDNDCBREPORTFEATURESDATA>(pvParms);
@@ -558,5 +558,5 @@
         }
 
-        case DragAndDropSvc::GUEST_DND_DISCONNECT:
+        case DragAndDropSvc::GUEST_DND_FN_DISCONNECT:
         {
             LogThisFunc(("Client disconnected\n"));
@@ -565,5 +565,5 @@
         }
 
-        case DragAndDropSvc::GUEST_DND_HG_ACK_OP:
+        case DragAndDropSvc::GUEST_DND_FN_HG_ACK_OP:
         {
             DragAndDropSvc::PVBOXDNDCBHGACKOPDATA pCBData = reinterpret_cast<DragAndDropSvc::PVBOXDNDCBHGACKOPDATA>(pvParms);
@@ -577,5 +577,5 @@
         }
 
-        case DragAndDropSvc::GUEST_DND_HG_REQ_DATA:
+        case DragAndDropSvc::GUEST_DND_FN_HG_REQ_DATA:
         {
             DragAndDropSvc::PVBOXDNDCBHGREQDATADATA pCBData = reinterpret_cast<DragAndDropSvc::PVBOXDNDCBHGREQDATADATA>(pvParms);
@@ -606,5 +606,5 @@
         }
 
-        case DragAndDropSvc::GUEST_DND_HG_EVT_PROGRESS:
+        case DragAndDropSvc::GUEST_DND_FN_HG_EVT_PROGRESS:
         {
             DragAndDropSvc::PVBOXDNDCBHGEVTPROGRESSDATA pCBData =
@@ -620,5 +620,5 @@
         }
 #ifdef VBOX_WITH_DRAG_AND_DROP_GH
-        case DragAndDropSvc::GUEST_DND_GH_ACK_PENDING:
+        case DragAndDropSvc::GUEST_DND_FN_GH_ACK_PENDING:
         {
             DragAndDropSvc::PVBOXDNDCBGHACKPENDINGDATA pCBData =
@@ -1319,5 +1319,5 @@
 {
     GuestDnDMsg Msg;
-    Msg.setType(HOST_DND_CANCEL);
+    Msg.setType(HOST_DND_FN_CANCEL);
     if (m_pState->m_uProtocolVersion >= 3)
         Msg.appendUInt32(0); /** @todo ContextID not used yet. */
Index: trunk/src/VBox/Main/src-client/GuestDnDSourceImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/GuestDnDSourceImpl.cpp	(revision 85744)
+++ trunk/src/VBox/Main/src-client/GuestDnDSourceImpl.cpp	(revision 85745)
@@ -275,5 +275,5 @@
 
     GuestDnDMsg Msg;
-    Msg.setType(HOST_DND_GH_REQ_PENDING);
+    Msg.setType(HOST_DND_FN_GH_REQ_PENDING);
     if (m_pState->m_uProtocolVersion >= 3)
         Msg.appendUInt32(0); /** @todo ContextID not used yet. */
@@ -1127,10 +1127,10 @@
      * Register callbacks.
      */
-    REGISTER_CALLBACK(GUEST_DND_CONNECT);
-    REGISTER_CALLBACK(GUEST_DND_DISCONNECT);
-    REGISTER_CALLBACK(GUEST_DND_GH_EVT_ERROR);
+    REGISTER_CALLBACK(GUEST_DND_FN_CONNECT);
+    REGISTER_CALLBACK(GUEST_DND_FN_DISCONNECT);
+    REGISTER_CALLBACK(GUEST_DND_FN_GH_EVT_ERROR);
     if (m_pState->m_uProtocolVersion >= 3)
-        REGISTER_CALLBACK(GUEST_DND_GH_SND_DATA_HDR);
-    REGISTER_CALLBACK(GUEST_DND_GH_SND_DATA);
+        REGISTER_CALLBACK(GUEST_DND_FN_GH_SND_DATA_HDR);
+    REGISTER_CALLBACK(GUEST_DND_FN_GH_SND_DATA);
 
     do
@@ -1140,5 +1140,5 @@
          */
         GuestDnDMsg Msg;
-        Msg.setType(HOST_DND_GH_EVT_DROPPED);
+        Msg.setType(HOST_DND_FN_GH_EVT_DROPPED);
         if (m_pState->m_uProtocolVersion >= 3)
             Msg.appendUInt32(0); /** @todo ContextID not used yet. */
@@ -1162,10 +1162,10 @@
      * Unregister callbacks.
      */
-    UNREGISTER_CALLBACK(GUEST_DND_CONNECT);
-    UNREGISTER_CALLBACK(GUEST_DND_DISCONNECT);
-    UNREGISTER_CALLBACK(GUEST_DND_GH_EVT_ERROR);
+    UNREGISTER_CALLBACK(GUEST_DND_FN_CONNECT);
+    UNREGISTER_CALLBACK(GUEST_DND_FN_DISCONNECT);
+    UNREGISTER_CALLBACK(GUEST_DND_FN_GH_EVT_ERROR);
     if (m_pState->m_uProtocolVersion >= 3)
-        UNREGISTER_CALLBACK(GUEST_DND_GH_SND_DATA_HDR);
-    UNREGISTER_CALLBACK(GUEST_DND_GH_SND_DATA);
+        UNREGISTER_CALLBACK(GUEST_DND_FN_GH_SND_DATA_HDR);
+    UNREGISTER_CALLBACK(GUEST_DND_FN_GH_SND_DATA);
 
 #undef REGISTER_CALLBACK
@@ -1240,14 +1240,14 @@
      */
     /* Guest callbacks. */
-    REGISTER_CALLBACK(GUEST_DND_CONNECT);
-    REGISTER_CALLBACK(GUEST_DND_DISCONNECT);
-    REGISTER_CALLBACK(GUEST_DND_GH_EVT_ERROR);
+    REGISTER_CALLBACK(GUEST_DND_FN_CONNECT);
+    REGISTER_CALLBACK(GUEST_DND_FN_DISCONNECT);
+    REGISTER_CALLBACK(GUEST_DND_FN_GH_EVT_ERROR);
     if (m_pState->m_uProtocolVersion >= 3)
-        REGISTER_CALLBACK(GUEST_DND_GH_SND_DATA_HDR);
-    REGISTER_CALLBACK(GUEST_DND_GH_SND_DATA);
-    REGISTER_CALLBACK(GUEST_DND_GH_SND_DIR);
+        REGISTER_CALLBACK(GUEST_DND_FN_GH_SND_DATA_HDR);
+    REGISTER_CALLBACK(GUEST_DND_FN_GH_SND_DATA);
+    REGISTER_CALLBACK(GUEST_DND_FN_GH_SND_DIR);
     if (m_pState->m_uProtocolVersion >= 2)
-        REGISTER_CALLBACK(GUEST_DND_GH_SND_FILE_HDR);
-    REGISTER_CALLBACK(GUEST_DND_GH_SND_FILE_DATA);
+        REGISTER_CALLBACK(GUEST_DND_FN_GH_SND_FILE_HDR);
+    REGISTER_CALLBACK(GUEST_DND_FN_GH_SND_FILE_DATA);
 
     const PDNDDROPPEDFILES pDF = &pCtx->Transfer.DroppedFiles;
@@ -1267,5 +1267,5 @@
          */
         GuestDnDMsg Msg;
-        Msg.setType(HOST_DND_GH_EVT_DROPPED);
+        Msg.setType(HOST_DND_FN_GH_EVT_DROPPED);
         if (m_pState->m_uProtocolVersion >= 3)
             Msg.appendUInt32(0); /** @todo ContextID not used yet. */
@@ -1293,12 +1293,12 @@
      * Unregister callbacks.
      */
-    UNREGISTER_CALLBACK(GUEST_DND_CONNECT);
-    UNREGISTER_CALLBACK(GUEST_DND_DISCONNECT);
-    UNREGISTER_CALLBACK(GUEST_DND_GH_EVT_ERROR);
-    UNREGISTER_CALLBACK(GUEST_DND_GH_SND_DATA_HDR);
-    UNREGISTER_CALLBACK(GUEST_DND_GH_SND_DATA);
-    UNREGISTER_CALLBACK(GUEST_DND_GH_SND_DIR);
-    UNREGISTER_CALLBACK(GUEST_DND_GH_SND_FILE_HDR);
-    UNREGISTER_CALLBACK(GUEST_DND_GH_SND_FILE_DATA);
+    UNREGISTER_CALLBACK(GUEST_DND_FN_CONNECT);
+    UNREGISTER_CALLBACK(GUEST_DND_FN_DISCONNECT);
+    UNREGISTER_CALLBACK(GUEST_DND_FN_GH_EVT_ERROR);
+    UNREGISTER_CALLBACK(GUEST_DND_FN_GH_SND_DATA_HDR);
+    UNREGISTER_CALLBACK(GUEST_DND_FN_GH_SND_DATA);
+    UNREGISTER_CALLBACK(GUEST_DND_FN_GH_SND_DIR);
+    UNREGISTER_CALLBACK(GUEST_DND_FN_GH_SND_FILE_HDR);
+    UNREGISTER_CALLBACK(GUEST_DND_FN_GH_SND_FILE_DATA);
 
 #undef REGISTER_CALLBACK
@@ -1369,14 +1369,14 @@
     switch (uMsg)
     {
-        case GUEST_DND_CONNECT:
+        case GUEST_DND_FN_CONNECT:
             /* Nothing to do here (yet). */
             break;
 
-        case GUEST_DND_DISCONNECT:
+        case GUEST_DND_FN_DISCONNECT:
             rc = VERR_CANCELLED;
             break;
 
 #ifdef VBOX_WITH_DRAG_AND_DROP_GH
-        case GUEST_DND_GH_SND_DATA_HDR:
+        case GUEST_DND_FN_GH_SND_DATA_HDR:
         {
             PVBOXDNDCBSNDDATAHDRDATA pCBData = reinterpret_cast<PVBOXDNDCBSNDDATAHDRDATA>(pvParms);
@@ -1388,5 +1388,5 @@
             break;
         }
-        case GUEST_DND_GH_SND_DATA:
+        case GUEST_DND_FN_GH_SND_DATA:
         {
             PVBOXDNDCBSNDDATADATA pCBData = reinterpret_cast<PVBOXDNDCBSNDDATADATA>(pvParms);
@@ -1398,5 +1398,5 @@
             break;
         }
-        case GUEST_DND_GH_EVT_ERROR:
+        case GUEST_DND_FN_GH_EVT_ERROR:
         {
             PVBOXDNDCBEVTERRORDATA pCBData = reinterpret_cast<PVBOXDNDCBEVTERRORDATA>(pvParms);
@@ -1507,14 +1507,14 @@
     switch (uMsg)
     {
-        case GUEST_DND_CONNECT:
+        case GUEST_DND_FN_CONNECT:
             /* Nothing to do here (yet). */
             break;
 
-        case GUEST_DND_DISCONNECT:
+        case GUEST_DND_FN_DISCONNECT:
             rc = VERR_CANCELLED;
             break;
 
 #ifdef VBOX_WITH_DRAG_AND_DROP_GH
-        case GUEST_DND_GH_SND_DATA_HDR:
+        case GUEST_DND_FN_GH_SND_DATA_HDR:
         {
             PVBOXDNDCBSNDDATAHDRDATA pCBData = reinterpret_cast<PVBOXDNDCBSNDDATAHDRDATA>(pvParms);
@@ -1526,5 +1526,5 @@
             break;
         }
-        case GUEST_DND_GH_SND_DATA:
+        case GUEST_DND_FN_GH_SND_DATA:
         {
             PVBOXDNDCBSNDDATADATA pCBData = reinterpret_cast<PVBOXDNDCBSNDDATADATA>(pvParms);
@@ -1536,5 +1536,5 @@
             break;
         }
-        case GUEST_DND_GH_SND_DIR:
+        case GUEST_DND_FN_GH_SND_DIR:
         {
             PVBOXDNDCBSNDDIRDATA pCBData = reinterpret_cast<PVBOXDNDCBSNDDIRDATA>(pvParms);
@@ -1546,5 +1546,5 @@
             break;
         }
-        case GUEST_DND_GH_SND_FILE_HDR:
+        case GUEST_DND_FN_GH_SND_FILE_HDR:
         {
             PVBOXDNDCBSNDFILEHDRDATA pCBData = reinterpret_cast<PVBOXDNDCBSNDFILEHDRDATA>(pvParms);
@@ -1557,5 +1557,5 @@
             break;
         }
-        case GUEST_DND_GH_SND_FILE_DATA:
+        case GUEST_DND_FN_GH_SND_FILE_DATA:
         {
             PVBOXDNDCBSNDFILEDATADATA pCBData = reinterpret_cast<PVBOXDNDCBSNDFILEDATADATA>(pvParms);
@@ -1582,5 +1582,5 @@
             break;
         }
-        case GUEST_DND_GH_EVT_ERROR:
+        case GUEST_DND_FN_GH_EVT_ERROR:
         {
             PVBOXDNDCBEVTERRORDATA pCBData = reinterpret_cast<PVBOXDNDCBEVTERRORDATA>(pvParms);
Index: trunk/src/VBox/Main/src-client/GuestDnDTargetImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/GuestDnDTargetImpl.cpp	(revision 85744)
+++ trunk/src/VBox/Main/src-client/GuestDnDTargetImpl.cpp	(revision 85745)
@@ -315,5 +315,5 @@
     {
         GuestDnDMsg Msg;
-        Msg.setType(HOST_DND_HG_EVT_ENTER);
+        Msg.setType(HOST_DND_FN_HG_EVT_ENTER);
         if (m_pState->m_uProtocolVersion >= 3)
             Msg.appendUInt32(0); /** @todo ContextID not used yet. */
@@ -392,5 +392,5 @@
     {
         GuestDnDMsg Msg;
-        Msg.setType(HOST_DND_HG_EVT_MOVE);
+        Msg.setType(HOST_DND_FN_HG_EVT_MOVE);
         if (m_pState->m_uProtocolVersion >= 3)
             Msg.appendUInt32(0); /** @todo ContextID not used yet. */
@@ -439,5 +439,5 @@
 
     GuestDnDMsg Msg;
-    Msg.setType(HOST_DND_HG_EVT_LEAVE);
+    Msg.setType(HOST_DND_FN_HG_EVT_LEAVE);
     if (m_pState->m_uProtocolVersion >= 3)
         Msg.appendUInt32(0); /** @todo ContextID not used yet. */
@@ -515,5 +515,5 @@
     {
         GuestDnDMsg Msg;
-        Msg.setType(HOST_DND_HG_EVT_DROPPED);
+        Msg.setType(HOST_DND_FN_HG_EVT_DROPPED);
         if (m_pState->m_uProtocolVersion >= 3)
             Msg.appendUInt32(0); /** @todo ContextID not used yet. */
@@ -851,5 +851,5 @@
     {
         GuestDnDMsg Msg;
-        Msg.setType(HOST_DND_HG_SND_DATA);
+        Msg.setType(HOST_DND_FN_HG_SND_DATA);
 
         if (m_pState->m_uProtocolVersion < 3)
@@ -905,5 +905,5 @@
 
     GuestDnDMsg Msg;
-    Msg.setType(HOST_DND_HG_SND_DATA_HDR);
+    Msg.setType(HOST_DND_FN_HG_SND_DATA_HDR);
 
     LogRel2(("DnD: Sending meta data header to guest (%RU64 bytes total data, %RU32 bytes meta data, %RU64 objects)\n",
@@ -949,5 +949,5 @@
     LogRel2(("DnD: Transferring host directory '%s' to guest\n", DnDTransferObjectGetSourcePath(pObj)));
 
-    pMsg->setType(HOST_DND_HG_SND_DIR);
+    pMsg->setType(HOST_DND_FN_HG_SND_DIR);
     if (m_pState->m_uProtocolVersion >= 3)
         pMsg->appendUInt32(0); /** @todo ContextID not used yet. */
@@ -1010,5 +1010,5 @@
                  * The just registered callback will be called by the guest afterwards.
                  */
-                pMsg->setType(HOST_DND_HG_SND_FILE_HDR);
+                pMsg->setType(HOST_DND_FN_HG_SND_FILE_HDR);
                 pMsg->appendUInt32(0); /** @todo ContextID not used yet. */
                 pMsg->appendString(pcszDstPath);                    /* pvName */
@@ -1072,5 +1072,5 @@
 
     /* Set the message type. */
-    pMsg->setType(HOST_DND_HG_SND_FILE_DATA);
+    pMsg->setType(HOST_DND_FN_HG_SND_FILE_DATA);
 
     const char *pcszSrcPath = DnDTransferObjectGetSourcePath(pObj);
@@ -1078,5 +1078,5 @@
 
     /* Protocol version 1 sends the file path *every* time with a new file chunk.
-     * In protocol version 2 we only do this once with HOST_DND_HG_SND_FILE_HDR. */
+     * In protocol version 2 we only do this once with HOST_DND_FN_HG_SND_FILE_HDR. */
     if (m_pState->m_uProtocolVersion <= 1)
     {
@@ -1168,13 +1168,13 @@
     switch (uMsg)
     {
-        case GUEST_DND_CONNECT:
+        case GUEST_DND_FN_CONNECT:
             /* Nothing to do here (yet). */
             break;
 
-        case GUEST_DND_DISCONNECT:
+        case GUEST_DND_FN_DISCONNECT:
             rc = VERR_CANCELLED;
             break;
 
-        case GUEST_DND_GET_NEXT_HOST_MSG:
+        case GUEST_DND_FN_GET_NEXT_HOST_MSG:
         {
             PVBOXDNDCBHGGETNEXTHOSTMSG pCBData = reinterpret_cast<PVBOXDNDCBHGGETNEXTHOSTMSG>(pvParms);
@@ -1197,5 +1197,5 @@
                     if (RT_SUCCESS(rc)) /* Return message type & required parameter count to the guest. */
                     {
-                        LogFlowFunc(("GUEST_DND_GET_NEXT_HOST_MSG -> %RU32 (%RU32 params)\n", pMsg->getType(), pMsg->getCount()));
+                        LogFlowFunc(("GUEST_DND_FN_GET_NEXT_HOST_MSG -> %RU32 (%RU32 params)\n", pMsg->getType(), pMsg->getCount()));
                         pCBData->uMsg   = pMsg->getType();
                         pCBData->cParms = pMsg->getCount();
@@ -1216,5 +1216,5 @@
             break;
         }
-        case GUEST_DND_GH_EVT_ERROR:
+        case GUEST_DND_FN_GH_EVT_ERROR:
         {
             PVBOXDNDCBEVTERRORDATA pCBData = reinterpret_cast<PVBOXDNDCBEVTERRORDATA>(pvParms);
@@ -1240,7 +1240,7 @@
             break;
         }
-        case HOST_DND_HG_SND_DIR:
-        case HOST_DND_HG_SND_FILE_HDR:
-        case HOST_DND_HG_SND_FILE_DATA:
+        case HOST_DND_FN_HG_SND_DIR:
+        case HOST_DND_FN_HG_SND_FILE_HDR:
+        case HOST_DND_FN_HG_SND_FILE_DATA:
         {
             PVBOXDNDCBHGGETNEXTHOSTMSGDATA pCBData
@@ -1400,13 +1400,13 @@
      */
     /* Guest callbacks. */
-    REGISTER_CALLBACK(GUEST_DND_CONNECT);
-    REGISTER_CALLBACK(GUEST_DND_DISCONNECT);
-    REGISTER_CALLBACK(GUEST_DND_GET_NEXT_HOST_MSG);
-    REGISTER_CALLBACK(GUEST_DND_GH_EVT_ERROR);
+    REGISTER_CALLBACK(GUEST_DND_FN_CONNECT);
+    REGISTER_CALLBACK(GUEST_DND_FN_DISCONNECT);
+    REGISTER_CALLBACK(GUEST_DND_FN_GET_NEXT_HOST_MSG);
+    REGISTER_CALLBACK(GUEST_DND_FN_GH_EVT_ERROR);
     /* Host callbacks. */
-    REGISTER_CALLBACK(HOST_DND_HG_SND_DIR);
+    REGISTER_CALLBACK(HOST_DND_FN_HG_SND_DIR);
     if (m_pState->m_uProtocolVersion >= 2)
-        REGISTER_CALLBACK(HOST_DND_HG_SND_FILE_HDR);
-    REGISTER_CALLBACK(HOST_DND_HG_SND_FILE_DATA);
+        REGISTER_CALLBACK(HOST_DND_FN_HG_SND_FILE_HDR);
+    REGISTER_CALLBACK(HOST_DND_FN_HG_SND_FILE_DATA);
 
     do
@@ -1495,13 +1495,13 @@
      */
     /* Guest callbacks. */
-    UNREGISTER_CALLBACK(GUEST_DND_CONNECT);
-    UNREGISTER_CALLBACK(GUEST_DND_DISCONNECT);
-    UNREGISTER_CALLBACK(GUEST_DND_GET_NEXT_HOST_MSG);
-    UNREGISTER_CALLBACK(GUEST_DND_GH_EVT_ERROR);
+    UNREGISTER_CALLBACK(GUEST_DND_FN_CONNECT);
+    UNREGISTER_CALLBACK(GUEST_DND_FN_DISCONNECT);
+    UNREGISTER_CALLBACK(GUEST_DND_FN_GET_NEXT_HOST_MSG);
+    UNREGISTER_CALLBACK(GUEST_DND_FN_GH_EVT_ERROR);
     /* Host callbacks. */
-    UNREGISTER_CALLBACK(HOST_DND_HG_SND_DIR);
+    UNREGISTER_CALLBACK(HOST_DND_FN_HG_SND_DIR);
     if (m_pState->m_uProtocolVersion >= 2)
-        UNREGISTER_CALLBACK(HOST_DND_HG_SND_FILE_HDR);
-    UNREGISTER_CALLBACK(HOST_DND_HG_SND_FILE_DATA);
+        UNREGISTER_CALLBACK(HOST_DND_FN_HG_SND_FILE_HDR);
+    UNREGISTER_CALLBACK(HOST_DND_FN_HG_SND_FILE_DATA);
 
 #undef REGISTER_CALLBACK
@@ -1606,6 +1606,6 @@
 
     /** @todo At the moment we only allow sending up to 64K raw data.
-     *        For protocol v1+v2: Fix this by using HOST_DND_HG_SND_MORE_DATA.
-     *        For protocol v3   : Send another HOST_DND_HG_SND_DATA message. */
+     *        For protocol v1+v2: Fix this by using HOST_DND_FN_HG_SND_MORE_DATA.
+     *        For protocol v3   : Send another HOST_DND_FN_HG_SND_DATA message. */
     if (!pCtx->Meta.cbData)
         return VINF_SUCCESS;