Index: trunk/src/VBox/Frontends/VirtualBox/VBoxUI.pro
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/VBoxUI.pro	(revision 85763)
+++ trunk/src/VBox/Frontends/VirtualBox/VBoxUI.pro	(revision 85764)
@@ -32,5 +32,4 @@
     src/settings/global/UIGlobalSettingsExtension.ui \
     src/settings/global/UIGlobalSettingsProxy.ui \
-    src/settings/machine/UIMachineSettingsNetwork.ui \
     src/settings/machine/UIMachineSettingsUSB.ui \
     src/settings/machine/UIMachineSettingsUSBFilterDetails.ui
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsNetwork.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsNetwork.cpp	(revision 85763)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsNetwork.cpp	(revision 85764)
@@ -16,14 +16,25 @@
  */
 
+/* Qt includes: */
+#include <QCheckBox>
+#include <QComboBox>
+#include <QGridLayout>
+#include <QLabel>
+#include <QPushButton>
+#include <QTextEdit>
+
 /* GUI includes: */
 #include "QIArrowButtonSwitch.h"
+#include "QILineEdit.h"
 #include "QITabWidget.h"
+#include "QIToolButton.h"
 #include "QIWidgetValidator.h"
+#include "UICommon.h"
 #include "UIConverter.h"
+#include "UIErrorString.h"
 #include "UIIconPool.h"
 #include "UIMachineSettingsNetwork.h"
-#include "UIErrorString.h"
 #include "UIExtraDataManager.h"
-#include "UICommon.h"
+#include "UINetworkAttachmentEditor.h"
 
 /* COM includes: */
@@ -142,6 +153,5 @@
 
 /** Machine settings: Network Adapter tab. */
-class UIMachineSettingsNetwork : public QIWithRetranslateUI<QWidget>,
-                                 public Ui::UIMachineSettingsNetwork
+class UIMachineSettingsNetwork : public QIWithRetranslateUI<QWidget>
 {
     Q_OBJECT;
@@ -200,4 +210,7 @@
     void prepareValidation();
 
+    /* Prepares widgets: */
+    void prepareWidgets();
+
     /* Helping stuff: */
     void populateComboboxes();
@@ -217,4 +230,25 @@
     KNetworkAdapterType m_enmAdapterType;
     UIPortForwardingDataList m_portForwardingRules;
+
+    /** @name Widgets
+     * @{ */
+       QLabel *m_pAttachmentTypeLabel;
+       QLabel *m_pAdapterNameLabel;
+       QLabel *m_pAdapterTypeLabel;
+       QLabel *m_pPromiscuousModeLabel;
+       QLabel *m_pMACLabel;
+       QLabel *m_pGenericPropertiesLabel;
+       UINetworkAttachmentEditor *m_pAttachmentTypeEditor;
+       QILineEdit *m_pMACEditor;
+       QIToolButton *m_pMACButton;
+       QIArrowButtonSwitch *m_pAdvancedArrow;
+       QCheckBox *m_pEnableAdapterCheckBox;
+       QCheckBox *m_pCableConnectedCheckBox;
+       QPushButton *m_pPortForwardingButton;
+       QComboBox *m_pPromiscuousModeCombo;
+       QComboBox *m_pAdapterTypeCombo;
+       QTextEdit *m_pGenericPropertiesTextEdit;
+       QWidget *m_pAdapterOptionsContainer;
+    /** @} */
 };
 
@@ -230,6 +264,5 @@
     , m_enmAdapterType(KNetworkAdapterType_Null)
 {
-    /* Apply UI decorations: */
-    Ui::UIMachineSettingsNetwork::setupUi(this);
+    prepareWidgets();
 
     /* Determine icon metric: */
@@ -567,6 +600,37 @@
 void UIMachineSettingsNetwork::retranslateUi()
 {
-    /* Translate uic generated strings: */
-    Ui::UIMachineSettingsNetwork::retranslateUi(this);
+    m_pEnableAdapterCheckBox->setWhatsThis(QApplication::translate("UIMachineSettingsNetwork", "When checked, plugs this virtual "
+                                                                   "network adapter into the virtual machine."));
+    m_pEnableAdapterCheckBox->setText(QApplication::translate("UIMachineSettingsNetwork", "&Enable Network Adapter"));
+    m_pAttachmentTypeLabel->setText(QApplication::translate("UIMachineSettingsNetwork", "&Attached to:"));
+    m_pAttachmentTypeEditor->setWhatsThis(QApplication::translate("UIMachineSettingsNetwork", "Selects how this virtual adapter "
+                                                                  "is attached to the real network of the Host OS."));
+    m_pAdapterNameLabel->setText(QApplication::translate("UIMachineSettingsNetwork", "&Name:"));
+    m_pAdvancedArrow->setText(QApplication::translate("UIMachineSettingsNetwork", "A&dvanced"));
+    m_pAdvancedArrow->setWhatsThis(QApplication::translate("UIMachineSettingsNetwork", "Shows additional network adapter options."));
+    m_pAdapterTypeLabel->setText(QApplication::translate("UIMachineSettingsNetwork", "Adapter &Type:"));
+    m_pAdapterTypeCombo->setWhatsThis(QApplication::translate("UIMachineSettingsNetwork", "Selects the type of the virtual network "
+                                                              "adapter. Depending on this value, VirtualBox will provide different "
+                                                              "network hardware to the virtual machine."));
+    m_pPromiscuousModeLabel->setText(QApplication::translate("UIMachineSettingsNetwork", "&Promiscuous Mode:"));
+    m_pPromiscuousModeCombo->setWhatsThis(QApplication::translate("UIMachineSettingsNetwork", "Selects the promiscuous mode policy "
+                                                                  "of the network adapter when attached to an internal network, "
+                                                                  "host only network or a bridge."));
+    m_pMACLabel->setText(QApplication::translate("UIMachineSettingsNetwork", "&MAC Address:"));
+    m_pMACEditor->setWhatsThis(QApplication::translate("UIMachineSettingsNetwork", "Holds the MAC address of this adapter. It contains "
+                                                       "exactly 12 characters chosen from {0-9,A-F}. Note that the second character "
+                                                       "must be an even digit."));
+    m_pMACButton->setWhatsThis(QApplication::translate("UIMachineSettingsNetwork", "Generates a new random MAC address."));
+    m_pGenericPropertiesLabel->setText(QApplication::translate("UIMachineSettingsNetwork", "Generic Properties:"));
+    m_pGenericPropertiesTextEdit->setWhatsThis(QApplication::translate("UIMachineSettingsNetwork", "Holds the configuration settings "
+                                                                       "for the network attachment driver. The settings should be of "
+                                                                       "the form <b>name=value</b> and will depend on the driver. "
+                                                                       "Use <b>shift-enter</b> to add a new entry."));
+    m_pCableConnectedCheckBox->setWhatsThis(QApplication::translate("UIMachineSettingsNetwork", "When checked, the virtual network "
+                                                                    "cable is plugged in."));
+    m_pCableConnectedCheckBox->setText(QApplication::translate("UIMachineSettingsNetwork", "&Cable Connected"));
+    m_pPortForwardingButton->setWhatsThis(QApplication::translate("UIMachineSettingsNetwork", "Displays a window to configure port "
+                                                                  "forwarding rules."));
+    m_pPortForwardingButton->setText(QApplication::translate("UIMachineSettingsNetwork", "&Port Forwarding"));
 
     /* Translate combo-boxes content: */
@@ -666,4 +730,114 @@
     /* Configure validation: */
     connect(m_pMACEditor, &QILineEdit::textChanged, m_pParent, &UIMachineSettingsNetworkPage::revalidate);
+}
+
+void UIMachineSettingsNetwork::prepareWidgets()
+{
+    if (objectName().isEmpty())
+        setObjectName(QStringLiteral("UIMachineSettingsNetwork"));
+    resize(430, 250);
+    QGridLayout *pMainLayout = new QGridLayout(this);
+    pMainLayout->setObjectName(QStringLiteral("pMainLayout"));
+    m_pEnableAdapterCheckBox = new QCheckBox(this);
+    m_pEnableAdapterCheckBox->setObjectName(QStringLiteral("m_pEnableAdapterCheckBox"));
+
+    pMainLayout->addWidget(m_pEnableAdapterCheckBox, 0, 0, 1, 2);
+    QSpacerItem *pHorizontalSpacer1 = new QSpacerItem(20, 0, QSizePolicy::Fixed, QSizePolicy::Minimum);
+    pMainLayout->addItem(pHorizontalSpacer1, 1, 0, 1, 1);
+
+    m_pAdapterOptionsContainer = new QWidget();
+    m_pAdapterOptionsContainer->setObjectName(QStringLiteral("m_pAdapterOptionsContainer"));
+    QGridLayout *pAdapterOptionsLayout = new QGridLayout(m_pAdapterOptionsContainer);
+    pAdapterOptionsLayout->setContentsMargins(0, 0, 0, 0);
+    pAdapterOptionsLayout->setObjectName(QStringLiteral("pAdapterOptionsLayout"));
+    m_pAttachmentTypeLabel = new QLabel(m_pAdapterOptionsContainer);
+    m_pAttachmentTypeLabel->setObjectName(QStringLiteral("m_pAttachmentTypeLabel"));
+    m_pAttachmentTypeLabel->setAlignment(Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter);
+    pAdapterOptionsLayout->addWidget(m_pAttachmentTypeLabel, 0, 0, 1, 1);
+
+    m_pAttachmentTypeEditor = new UINetworkAttachmentEditor(m_pAdapterOptionsContainer);
+    m_pAttachmentTypeEditor->setObjectName(QStringLiteral("m_pAttachmentTypeEditor"));
+    pAdapterOptionsLayout->addWidget(m_pAttachmentTypeEditor, 0, 1, 2, 3);
+
+    m_pAdapterNameLabel = new QLabel(m_pAdapterOptionsContainer);
+    m_pAdapterNameLabel->setObjectName(QStringLiteral("m_pAdapterNameLabel"));
+    m_pAdapterNameLabel->setAlignment(Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter);
+    pAdapterOptionsLayout->addWidget(m_pAdapterNameLabel, 1, 0, 1, 1);
+
+    QHBoxLayout *pAdvancedButtonLayout = new QHBoxLayout();
+    pAdvancedButtonLayout->setContentsMargins(0, 0, 0, 0);
+    pAdvancedButtonLayout->setObjectName(QStringLiteral("pAdvancedButtonLayout"));
+    QSpacerItem *pHorizontalSpacer2 = new QSpacerItem(0, 0, QSizePolicy::Expanding, QSizePolicy::Minimum);
+    pAdvancedButtonLayout->addItem(pHorizontalSpacer2);
+
+    m_pAdvancedArrow = new QIArrowButtonSwitch(m_pAdapterOptionsContainer);
+    m_pAdvancedArrow->setObjectName(QStringLiteral("m_pAdvancedArrow"));
+    pAdvancedButtonLayout->addWidget(m_pAdvancedArrow);
+    pAdapterOptionsLayout->addLayout(pAdvancedButtonLayout, 2, 0, 1, 1);
+
+    m_pAdapterTypeLabel = new QLabel(m_pAdapterOptionsContainer);
+    m_pAdapterTypeLabel->setObjectName(QStringLiteral("m_pAdapterTypeLabel"));
+    m_pAdapterTypeLabel->setAlignment(Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter);
+    pAdapterOptionsLayout->addWidget(m_pAdapterTypeLabel, 3, 0, 1, 1);
+
+    m_pAdapterTypeCombo = new QComboBox(m_pAdapterOptionsContainer);
+    m_pAdapterTypeCombo->setObjectName(QStringLiteral("m_pAdapterTypeCombo"));
+    QSizePolicy sizePolicy(QSizePolicy::MinimumExpanding, QSizePolicy::Fixed);
+    sizePolicy.setHorizontalStretch(1);
+    sizePolicy.setVerticalStretch(0);
+    sizePolicy.setHeightForWidth(m_pAdapterTypeCombo->sizePolicy().hasHeightForWidth());
+    m_pAdapterTypeCombo->setSizePolicy(sizePolicy);
+    pAdapterOptionsLayout->addWidget(m_pAdapterTypeCombo, 3, 1, 1, 3);
+
+    m_pPromiscuousModeLabel = new QLabel(m_pAdapterOptionsContainer);
+    m_pPromiscuousModeLabel->setObjectName(QStringLiteral("m_pPromiscuousModeLabel"));
+    m_pPromiscuousModeLabel->setAlignment(Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter);
+    pAdapterOptionsLayout->addWidget(m_pPromiscuousModeLabel, 4, 0, 1, 1);
+
+    m_pPromiscuousModeCombo = new QComboBox(m_pAdapterOptionsContainer);
+    m_pPromiscuousModeCombo->setObjectName(QStringLiteral("m_pPromiscuousModeCombo"));
+    sizePolicy.setHeightForWidth(m_pPromiscuousModeCombo->sizePolicy().hasHeightForWidth());
+    m_pPromiscuousModeCombo->setSizePolicy(sizePolicy);
+    pAdapterOptionsLayout->addWidget(m_pPromiscuousModeCombo, 4, 1, 1, 3);
+
+    m_pMACLabel = new QLabel(m_pAdapterOptionsContainer);
+    m_pMACLabel->setObjectName(QStringLiteral("m_pMACLabel"));
+    m_pMACLabel->setAlignment(Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter);
+    pAdapterOptionsLayout->addWidget(m_pMACLabel, 5, 0, 1, 1);
+
+    m_pMACEditor = new QILineEdit(m_pAdapterOptionsContainer);
+    m_pMACEditor->setObjectName(QStringLiteral("m_pMACEditor"));
+    sizePolicy.setHeightForWidth(m_pMACEditor->sizePolicy().hasHeightForWidth());
+    m_pMACEditor->setSizePolicy(sizePolicy);
+    pAdapterOptionsLayout->addWidget(m_pMACEditor, 5, 1, 1, 2);
+
+    m_pMACButton = new QIToolButton(m_pAdapterOptionsContainer);
+    m_pMACButton->setObjectName(QStringLiteral("m_pMACButton"));
+    pAdapterOptionsLayout->addWidget(m_pMACButton, 5, 3, 1, 1);
+
+    m_pGenericPropertiesLabel = new QLabel(m_pAdapterOptionsContainer);
+    m_pGenericPropertiesLabel->setObjectName(QStringLiteral("m_pGenericPropertiesLabel"));
+    m_pGenericPropertiesLabel->setAlignment(Qt::AlignRight|Qt::AlignTrailing|Qt::AlignTop);
+    pAdapterOptionsLayout->addWidget(m_pGenericPropertiesLabel, 6, 0, 1, 1);
+
+    m_pGenericPropertiesTextEdit = new QTextEdit(m_pAdapterOptionsContainer);
+    m_pGenericPropertiesTextEdit->setObjectName(QStringLiteral("m_pGenericPropertiesTextEdit"));
+    pAdapterOptionsLayout->addWidget(m_pGenericPropertiesTextEdit, 6, 1, 1, 3);
+
+    m_pCableConnectedCheckBox = new QCheckBox(m_pAdapterOptionsContainer);
+    m_pCableConnectedCheckBox->setObjectName(QStringLiteral("m_pCableConnectedCheckBox"));
+    pAdapterOptionsLayout->addWidget(m_pCableConnectedCheckBox, 7, 1, 1, 3);
+
+    m_pPortForwardingButton = new QPushButton(m_pAdapterOptionsContainer);
+    m_pPortForwardingButton->setObjectName(QStringLiteral("m_pPortForwardingButton"));
+    pAdapterOptionsLayout->addWidget(m_pPortForwardingButton, 8, 1, 1, 1);
+
+    QSpacerItem *pVerticalSpacer = new QSpacerItem(0, 0, QSizePolicy::Minimum, QSizePolicy::Expanding);
+    pAdapterOptionsLayout->addItem(pVerticalSpacer, 9, 0, 1, 4);
+    pMainLayout->addWidget(m_pAdapterOptionsContainer, 1, 1, 1, 1);
+
+    m_pAdapterTypeLabel->setBuddy(m_pAdapterTypeCombo);
+    m_pPromiscuousModeLabel->setBuddy(m_pPromiscuousModeCombo);
+    m_pMACLabel->setBuddy(m_pMACEditor);
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsNetwork.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsNetwork.h	(revision 85763)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsNetwork.h	(revision 85764)
@@ -24,5 +24,4 @@
 /* GUI includes: */
 #include "UISettingsPage.h"
-#include "UIMachineSettingsNetwork.gen.h"
 #include "UIMachineSettingsPortForwardingDlg.h"
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsNetwork.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsNetwork.ui	(revision 85763)
+++ 	(revision )
@@ -1,282 +1,0 @@
-<ui version="4.0">
- <comment>
- VBox frontends: Qt GUI ("VirtualBox"):
-
- Copyright (C) 2008-2020 Oracle Corporation
-
- This file is part of VirtualBox Open Source Edition (OSE), as
- available from http://www.virtualbox.org. This file is free software;
- you can redistribute it and/or modify it under the terms of the GNU
- General Public License (GPL) as published by the Free Software
- Foundation, in version 2 as it comes in the "COPYING" file of the
- VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- </comment>
- <class>UIMachineSettingsNetwork</class>
- <widget class="QWidget" name="UIMachineSettingsNetwork">
-  <property name="geometry">
-   <rect>
-    <x>0</x>
-    <y>0</y>
-    <width>430</width>
-    <height>250</height>
-   </rect>
-  </property>
-  <layout class="QGridLayout" name="m_pMainLayout">
-   <item row="0" column="0" colspan="2">
-    <widget class="QCheckBox" name="m_pEnableAdapterCheckBox">
-     <property name="whatsThis">
-      <string>When checked, plugs this virtual network adapter into the virtual machine.</string>
-     </property>
-     <property name="text">
-      <string>&amp;Enable Network Adapter</string>
-     </property>
-    </widget>
-   </item>
-   <item row="1" column="0">
-    <spacer name="m_pHorizontalSpacer1">
-     <property name="orientation">
-      <enum>Qt::Horizontal</enum>
-     </property>
-     <property name="sizeType">
-      <enum>QSizePolicy::Fixed</enum>
-     </property>
-     <property name="sizeHint" stdset="0">
-      <size>
-       <width>20</width>
-       <height>0</height>
-      </size>
-     </property>
-    </spacer>
-   </item>
-   <item row="1" column="1">
-    <widget class="QWidget" name="m_pAdapterOptionsContainer" native="1">
-     <layout class="QGridLayout" name="m_pAdapterOptionsLayout">
-      <property name="margin">
-       <number>0</number>
-      </property>
-      <item row="0" column="0">
-       <widget class="QLabel" name="m_pAttachmentTypeLabel">
-        <property name="text">
-         <string>&amp;Attached to:</string>
-        </property>
-        <property name="alignment">
-         <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
-        </property>
-       </widget>
-      </item>
-      <item row="0" column="1" rowspan="2" colspan="3">
-       <widget class="UINetworkAttachmentEditor" name="m_pAttachmentTypeEditor">
-        <property name="whatsThis">
-         <string>Selects how this virtual adapter is attached to the real network of the Host OS.</string>
-        </property>
-       </widget>
-      </item>
-      <item row="1" column="0">
-       <widget class="QLabel" name="m_pAdapterNameLabel">
-        <property name="text">
-         <string>&amp;Name:</string>
-        </property>
-        <property name="alignment">
-         <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
-        </property>
-       </widget>
-      </item>
-      <item row="2" column="0">
-       <layout class="QHBoxLayout" name="m_pAdvancedButtonLayout">
-        <property name="margin">
-         <number>0</number>
-        </property>
-        <item>
-         <spacer name="m_pHorizontalSpacer2">
-          <property name="orientation">
-           <enum>Qt::Horizontal</enum>
-          </property>
-          <property name="sizeHint" stdset="0">
-           <size>
-            <width>0</width>
-            <height>0</height>
-           </size>
-          </property>
-         </spacer>
-        </item>
-        <item>
-         <widget class="QIArrowButtonSwitch" native="1" name="m_pAdvancedArrow">
-          <property name="text">
-           <string>A&amp;dvanced</string>
-          </property>
-          <property name="whatsThis">
-           <string>Shows additional network adapter options.</string>
-          </property>
-         </widget>
-        </item>
-       </layout>
-      </item>
-      <item row="3" column="0">
-       <widget class="QLabel" name="m_pAdapterTypeLabel">
-        <property name="text">
-         <string>Adapter &amp;Type:</string>
-        </property>
-        <property name="alignment">
-         <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
-        </property>
-        <property name="buddy">
-         <cstring>m_pAdapterTypeCombo</cstring>
-        </property>
-       </widget>
-      </item>
-      <item row="3" column="1" colspan="3">
-       <widget class="QComboBox" name="m_pAdapterTypeCombo">
-        <property name="sizePolicy">
-         <sizepolicy hsizetype="MinimumExpanding" vsizetype="Fixed">
-          <horstretch>1</horstretch>
-          <verstretch>0</verstretch>
-         </sizepolicy>
-        </property>
-        <property name="whatsThis">
-         <string>Selects the type of the virtual network adapter. Depending on this value, VirtualBox will provide different network hardware to the virtual machine.</string>
-        </property>
-       </widget>
-      </item>
-      <item row="4" column="0">
-       <widget class="QLabel" name="m_pPromiscuousModeLabel">
-        <property name="text">
-         <string>&amp;Promiscuous Mode:</string>
-        </property>
-        <property name="alignment">
-         <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
-        </property>
-        <property name="buddy">
-         <cstring>m_pPromiscuousModeCombo</cstring>
-        </property>
-       </widget>
-      </item>
-      <item row="4" column="1" colspan="3">
-       <widget class="QComboBox" name="m_pPromiscuousModeCombo">
-        <property name="sizePolicy">
-         <sizepolicy hsizetype="MinimumExpanding" vsizetype="Fixed">
-          <horstretch>1</horstretch>
-          <verstretch>0</verstretch>
-         </sizepolicy>
-        </property>
-        <property name="whatsThis">
-         <string>Selects the promiscuous mode policy of the network adapter when attached to an internal network, host only network or a bridge.</string>
-        </property>
-       </widget>
-      </item>
-      <item row="5" column="0">
-       <widget class="QLabel" name="m_pMACLabel">
-        <property name="text">
-         <string>&amp;MAC Address:</string>
-        </property>
-        <property name="alignment">
-         <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
-        </property>
-        <property name="buddy">
-         <cstring>m_pMACEditor</cstring>
-        </property>
-       </widget>
-      </item>
-      <item row="5" column="1" colspan="2">
-       <widget class="QILineEdit" name="m_pMACEditor">
-        <property name="sizePolicy">
-         <sizepolicy hsizetype="MinimumExpanding" vsizetype="Fixed">
-          <horstretch>1</horstretch>
-          <verstretch>0</verstretch>
-         </sizepolicy>
-        </property>
-        <property name="whatsThis">
-         <string>Holds the MAC address of this adapter. It contains exactly 12 characters chosen from {0-9,A-F}. Note that the second character must be an even digit.</string>
-        </property>
-       </widget>
-      </item>
-      <item row="5" column="3">
-       <widget class="QIToolButton" name="m_pMACButton">
-        <property name="whatsThis">
-         <string>Generates a new random MAC address.</string>
-        </property>
-       </widget>
-      </item>
-      <item row="6" column="0">
-       <widget class="QLabel" name="m_pGenericPropertiesLabel">
-        <property name="text">
-         <string>Generic Properties:</string>
-        </property>
-        <property name="alignment">
-         <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignTop</set>
-        </property>
-       </widget>
-      </item>
-      <item row="6" column="1" colspan="3">
-       <widget class="QTextEdit" name="m_pGenericPropertiesTextEdit">
-        <property name="whatsThis">
-         <string>Holds the configuration settings for the network attachment driver. The settings should be of the form &lt;b&gt;name=value&lt;/b&gt; and will depend on the driver. Use &lt;b&gt;shift-enter&lt;/b&gt; to add a new entry.</string>
-        </property>
-       </widget>
-      </item>
-      <item row="7" column="1" colspan="3">
-       <widget class="QCheckBox" name="m_pCableConnectedCheckBox">
-        <property name="whatsThis">
-         <string>When checked, the virtual network cable is plugged in.</string>
-        </property>
-        <property name="text">
-         <string>&amp;Cable Connected</string>
-        </property>
-       </widget>
-      </item>
-      <item row="8" column="1">
-       <widget class="QPushButton" name="m_pPortForwardingButton">
-        <property name="whatsThis">
-         <string>Displays a window to configure port forwarding rules.</string>
-        </property>
-        <property name="text">
-         <string>&amp;Port Forwarding</string>
-        </property>
-       </widget>
-      </item>
-      <item row="9" column="0" colspan="4">
-       <spacer name="m_pVerticalSpacer">
-        <property name="orientation">
-         <enum>Qt::Vertical</enum>
-        </property>
-        <property name="sizeHint" stdset="0">
-         <size>
-          <width>0</width>
-          <height>0</height>
-         </size>
-        </property>
-       </spacer>
-      </item>
-     </layout>
-    </widget>
-   </item>
-  </layout>
- </widget>
- <customwidgets>
-  <customwidget>
-   <class>QILineEdit</class>
-   <extends>QLineEdit</extends>
-   <header>QILineEdit.h</header>
-  </customwidget>
-  <customwidget>
-   <class>QIArrowButtonSwitch</class>
-   <extends>QWidget</extends>
-   <header>QIArrowButtonSwitch.h</header>
-   <container>1</container>
-  </customwidget>
-  <customwidget>
-   <class>QIToolButton</class>
-   <extends>QToolButton</extends>
-   <header>QIToolButton.h</header>
-  </customwidget>
-  <customwidget>
-   <class>UINetworkAttachmentEditor</class>
-   <extends>QWidget</extends>
-   <header>UINetworkAttachmentEditor.h</header>
-  </customwidget>
- </customwidgets>
- <resources>
-  <include location="../VirtualBox1.qrc"/>
- </resources>
- <connections/>
-</ui>