Index: /trunk/src/VBox/Frontends/VirtualBox/VBoxUI.pro
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/VBoxUI.pro	(revision 85807)
+++ /trunk/src/VBox/Frontends/VirtualBox/VBoxUI.pro	(revision 85808)
@@ -25,5 +25,4 @@
     src/settings/global/UIGlobalSettingsGeneral.ui \
     src/settings/global/UIGlobalSettingsLanguage.ui \
-    src/settings/global/UIGlobalSettingsNetwork.ui \
     src/settings/global/UIGlobalSettingsExtension.ui \
     src/settings/global/UIGlobalSettingsProxy.ui
Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsNetwork.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsNetwork.cpp	(revision 85807)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsNetwork.cpp	(revision 85808)
@@ -17,15 +17,19 @@
 
 /* Qt includes: */
+#include <QHBoxLayout>
 #include <QHeaderView>
 #include <QMenu>
 
 /* GUI includes: */
+#include "QILabelSeparator.h"
+#include "QITreeWidget.h"
 #include "UICommon.h"
-#include "UIIconPool.h"
 #include "UIConverter.h"
 #include "UIErrorString.h"
-#include "UIMessageCenter.h"
 #include "UIGlobalSettingsNetwork.h"
 #include "UIGlobalSettingsNetworkDetailsNAT.h"
+#include "UIIconPool.h"
+#include "UIMessageCenter.h"
+#include "UIToolBar.h"
 
 /* COM includes: */
@@ -215,4 +219,8 @@
     : m_pActionAddNATNetwork(0), m_pActionRemoveNATNetwork(0), m_pActionEditNATNetwork(0)
     , m_pCache(0)
+    , m_pTreeNetworkNAT(0)
+    , m_pNetworkLabel(0)
+    , m_pLayoutNAT(0)
+    , m_pToolbarNetworkNAT(0)
 {
     /* Prepare: */
@@ -340,6 +348,6 @@
 void UIGlobalSettingsNetwork::retranslateUi()
 {
-    /* Translate uic generated strings: */
-    Ui::UIGlobalSettingsNetwork::retranslateUi(this);
+    m_pNetworkLabel->setText(tr("&NAT Networks"));
+    m_pTreeNetworkNAT->setWhatsThis(tr("Lists all available NAT networks."));
 
     /* Translate tree-widget columns: */
@@ -478,6 +486,5 @@
 void UIGlobalSettingsNetwork::prepare()
 {
-    /* Apply UI decorations: */
-    Ui::UIGlobalSettingsNetwork::setupUi(this);
+    prepareWidgets();
 
     /* Prepare cache: */
@@ -498,4 +505,37 @@
     /* Apply language settings: */
     retranslateUi();
+}
+
+void UIGlobalSettingsNetwork::prepareWidgets()
+{
+    if (objectName().isEmpty())
+        setObjectName(QStringLiteral("UIGlobalSettingsNetwork"));
+    QVBoxLayout *pMainLayout = new QVBoxLayout(this);
+    pMainLayout->setContentsMargins(0, 0, 0, 0);
+    pMainLayout->setObjectName(QStringLiteral("pMainLayout"));
+    m_pNetworkLabel = new QILabelSeparator();
+    m_pNetworkLabel->setObjectName(QStringLiteral("m_pNetworkLabel"));
+    pMainLayout->addWidget(m_pNetworkLabel);
+
+    m_pLayoutNAT = new QHBoxLayout();
+    m_pLayoutNAT->setSpacing(3);
+    m_pLayoutNAT->setObjectName(QStringLiteral("m_pLayoutNAT"));
+    m_pTreeNetworkNAT = new QITreeWidget();
+    m_pTreeNetworkNAT->setObjectName(QStringLiteral("m_pTreeNetworkNAT"));
+    QSizePolicy sizePolicy(QSizePolicy::MinimumExpanding, QSizePolicy::MinimumExpanding);
+    sizePolicy.setHorizontalStretch(0);
+    sizePolicy.setVerticalStretch(0);
+    sizePolicy.setHeightForWidth(m_pTreeNetworkNAT->sizePolicy().hasHeightForWidth());
+    m_pTreeNetworkNAT->setSizePolicy(sizePolicy);
+    m_pTreeNetworkNAT->setMinimumSize(QSize(0, 150));
+    m_pTreeNetworkNAT->setRootIsDecorated(false);
+    m_pLayoutNAT->addWidget(m_pTreeNetworkNAT);
+
+    m_pToolbarNetworkNAT = new UIToolBar();
+    m_pToolbarNetworkNAT->setObjectName(QStringLiteral("m_pToolbarNetworkNAT"));
+    m_pLayoutNAT->addWidget(m_pToolbarNetworkNAT);
+
+    pMainLayout->addLayout(m_pLayoutNAT);
+    m_pNetworkLabel->setBuddy(m_pTreeNetworkNAT);
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsNetwork.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsNetwork.h	(revision 85807)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsNetwork.h	(revision 85808)
@@ -24,9 +24,12 @@
 /* GUI includes: */
 #include "UISettingsPage.h"
-#include "UIGlobalSettingsNetwork.gen.h"
 #include "UIPortForwardingTable.h"
 
 /* Forward declarations: */
+class QILabelSeparator;
+class QITreeWidget;
+class QTreeWidgetItem;
 class UIItemNetworkNAT;
+class UIToolBar;
 struct UIDataSettingsGlobalNetwork;
 struct UIDataSettingsGlobalNetworkNAT;
@@ -36,6 +39,5 @@
 
 /** Global settings: Network page. */
-class SHARED_LIBRARY_STUFF UIGlobalSettingsNetwork : public UISettingsPageGlobal,
-                                                     public Ui::UIGlobalSettingsNetwork
+class SHARED_LIBRARY_STUFF UIGlobalSettingsNetwork : public UISettingsPageGlobal
 {
     Q_OBJECT;
@@ -90,4 +92,6 @@
     /** Prepares all. */
     void prepare();
+    /** Prepares widgets. */
+    void prepareWidgets();
     /** Prepares NAT network tree. */
     void prepareNATNetworkTree();
@@ -132,4 +136,12 @@
     /** Holds the page data cache instance. */
     UISettingsCacheGlobalNetwork *m_pCache;
+
+    /** @name Widgets
+     * @{ */
+       QITreeWidget *m_pTreeNetworkNAT;
+       QILabelSeparator *m_pNetworkLabel;
+       QHBoxLayout *m_pLayoutNAT;
+       UIToolBar *m_pToolbarNetworkNAT;
+    /** @} */
 };
 
Index: unk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsNetwork.ui
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsNetwork.ui	(revision 85807)
+++ 	(revision )
@@ -1,84 +1,0 @@
-<ui version="4.0">
- <comment>
- VBox frontends: Qt GUI ("VirtualBox"):
-
- Copyright (C) 2009-2020 Oracle Corporation
-
- This file is part of VirtualBox Open Source Edition (OSE), as
- available from http://www.virtualbox.org. This file is free software;
- you can redistribute it and/or modify it under the terms of the GNU
- General Public License (GPL) as published by the Free Software
- Foundation, in version 2 as it comes in the "COPYING" file of the
- VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- </comment>
- <class>UIGlobalSettingsNetwork</class>
- <widget class="QWidget" name="UIGlobalSettingsNetwork">
-  <layout class="QVBoxLayout">
-   <property name="margin">
-    <number>0</number>
-   </property>
-   <item>
-    <widget class="QILabelSeparator" native="1" name="m_pNetworkLabel">
-     <property name="text">
-     <string>&amp;NAT Networks</string>
-     </property>
-     <property name="buddy">
-      <cstring>m_pTreeNetworkNAT</cstring>
-     </property>
-    </widget>
-   </item>
-   <item>
-    <layout class="QHBoxLayout" name="m_pLayoutNAT">
-     <property name="spacing">
-      <number>3</number>
-     </property>
-     <item>
-      <widget class="QITreeWidget" name="m_pTreeNetworkNAT">
-       <property name="sizePolicy">
-        <sizepolicy hsizetype="MinimumExpanding" vsizetype="MinimumExpanding">
-         <horstretch>0</horstretch>
-         <verstretch>0</verstretch>
-        </sizepolicy>
-       </property>
-       <property name="minimumSize">
-        <size>
-         <width>0</width>
-         <height>150</height>
-        </size>
-       </property>
-       <property name="whatsThis">
-        <string>Lists all available NAT networks.</string>
-       </property>
-       <property name="rootIsDecorated">
-        <bool>false</bool>
-       </property>
-      </widget>
-     </item>
-     <item>
-      <widget class="UIToolBar" name="m_pToolbarNetworkNAT"/>
-     </item>
-    </layout>
-   </item>
-</layout>
-</widget>
- <customwidgets>
-  <customwidget>
-   <class>QILabelSeparator</class>
-   <extends>QLabel</extends>
-   <header>QILabelSeparator.h</header>
-  </customwidget>
-  <customwidget>
-   <class>UIToolBar</class>
-   <extends>QToolBar</extends>
-   <header>UIToolBar.h</header>
-  </customwidget>
-  <customwidget>
-   <class>QITreeWidget</class>
-   <extends>QTreeWidget</extends>
-   <header>QITreeWidget.h</header>
-  </customwidget>
- </customwidgets>
- <resources/>
- <connections/>
-</ui>
Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsNetworkDetailsNAT.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsNetworkDetailsNAT.cpp	(revision 85807)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsNetworkDetailsNAT.cpp	(revision 85808)
@@ -19,4 +19,5 @@
 #include <QCheckBox>
 #include <QRegExpValidator>
+#include <QGridLayout>
 #include <QLabel>
 #include <QLineEdit>